//
//  ViewController.m
//  车辆认证
//
//  Created by AS150701001 on 16/4/14.
//  Copyright © 2016年 lele. All rights reserved.
//


#define  kScreenWidth [UIScreen mainScreen].bounds.size.width
#define  kScreenHeight [UIScreen mainScreen].bounds.size.height
#define  kDuration   0.5
#define  kCellHeight 44.0


#define kTabViewWidth  (kScreenWidth * 0.6)
#import "ViewController.h"
#import "MainCar.h"     
#import "subName.h"

@interface ViewController ()<UITableViewDataSource,UITableViewDelegate>
{
    NSInteger _selectMainRow; // 记录主表选择的行号
}
@property(nonatomic,weak) UITableView* mainTabView;
@property(nonatomic,weak) UITableView* subTabView;
@property(nonatomic,strong) NSArray* carList;
@property(nonatomic,weak) UIButton* detailBtn;
@property(nonatomic,copy) NSString* selectCarType; // 记录选择的车型
@property(nonatomic,copy) NSString* selectCarIcon; // 记录选择车型的图标
@property(nonatomic,weak) UIButton* cover; // 遮盖
@property(nonatomic,weak) UILabel* titleLabel; // 遮盖

@end

@implementation ViewController
-(NSArray*)carList
{
    if (_carList==nil) {
        _carList=[MainCar mainCars];
    }
    return _carList;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    [self buildUI];
}

-(void)buildUI
{
    // 创建车辆认证按钮
    //添加 Label
    UILabel* car= [self labelWithTitle:@"  车型品牌"];
    car.backgroundColor=[UIColor groupTableViewBackgroundColor];
    car.frame=CGRectMake(0, 50, kScreenWidth, kCellHeight);
    
    //添加右端图片
    CGFloat imageW=kCellHeight;
    CGFloat imageH=kCellHeight;
    
    CGFloat imageX=kScreenWidth-imageW-5;
    CGFloat imageY=50;
    
    
    UIImageView* image1=[[UIImageView alloc] initWithFrame:CGRectMake(imageX, imageY, imageW, imageH)];
    image1.contentMode=UIViewContentModeCenter;
    image1.image=[UIImage imageNamed:@"arrow_right"];
    [self.view addSubview:image1];
    
    // 添加描述 Label
    CGFloat labelX=0;
    CGFloat labelY=50;
    CGFloat labelW=imageX;
    CGFloat labelH=kCellHeight;
    
    
    UIButton* detailBtn=[[UIButton alloc] initWithFrame:CGRectMake(labelX, labelY, labelW, labelH)];
    //detalLabel.backgroundColor=[UIColor redColor];
    detailBtn.titleLabel.font=[UIFont systemFontOfSize:14];
    [detailBtn setTitle:@"请选择车型" forState:UIControlStateNormal];
    [detailBtn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    detailBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    [self.view addSubview:detailBtn];
    self.detailBtn=detailBtn;
    [detailBtn addTarget:self action:@selector(btnClick) forControlEvents:UIControlEventTouchUpInside];
    
    UIEdgeInsets insert=UIEdgeInsetsMake(0, 0, 0, 5);
    [detailBtn setImageEdgeInsets:insert];
    detailBtn.adjustsImageWhenHighlighted=NO;
    
    
    UIView* mainView=[[UIView alloc] initWithFrame:CGRectMake(0, 0, 0, 44)];
    mainView.backgroundColor=[UIColor  whiteColor];
    UILabel* label=[[UILabel alloc] initWithFrame:CGRectMake(0, 0, kTabViewWidth, 43)];
    label.text=@"请选择";
    label.textAlignment=NSTextAlignmentCenter;
    UIView* lineView=[[UIView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(label.frame),kTabViewWidth, 1)];
    lineView.backgroundColor=[UIColor lightGrayColor];
    
    [mainView addSubview:label];
    [mainView addSubview:lineView];
    
    UIView* subView=[[UIView alloc] initWithFrame:CGRectMake(0, 0, 0, 44)];
    subView.backgroundColor=[UIColor whiteColor];
    
    UILabel* label2=[[UILabel alloc] initWithFrame:CGRectMake(0, 0, kTabViewWidth, 43)];
    label2.text=@"请选择";
    label2.textAlignment=NSTextAlignmentCenter;
    self.titleLabel=label2;
    
    UIButton* closeBtn=[[UIButton alloc] initWithFrame:CGRectMake(0, 0, 43, 43)];
    [closeBtn setImage:[UIImage imageNamed:@"btn_navigation_close"] forState:UIControlStateNormal];
    [closeBtn addTarget:self action:@selector(close) forControlEvents:UIControlEventTouchUpInside];
    
    UIView* lineView2=[[UIView alloc] initWithFrame:CGRectMake(0, 43,kTabViewWidth, 1)];
    lineView2.backgroundColor=[UIColor lightGrayColor];
    
    [subView addSubview:label2];
    [subView addSubview:lineView2];
    [subView addSubview:closeBtn];
    
    // 添加遮盖
    UIButton* cover=[[UIButton alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight)];
    cover.alpha=0.0;
    cover.backgroundColor=[UIColor blackColor];
    [cover addTarget:self action:@selector(coverClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:cover];
    self.cover=cover;
    
    self.mainTabView=[self tabView];
    self.mainTabView.tableHeaderView=mainView;
    
    self.subTabView=[self tabView];
    self.subTabView.tableHeaderView=subView;
    
}

-(UILabel*) labelWithTitle:(NSString*)title
{
    UILabel* label= [[UILabel alloc] init];
    label.text=title;
    
    [self.view addSubview:label];
    return label;
}


-(UITableView*)tabView
{
    UITableView* TabView=[[UITableView alloc] initWithFrame:CGRectMake(kScreenWidth, 0, kScreenWidth * 0.6, kScreenHeight)];
    TabView.dataSource=self;
    TabView.delegate=self;
    //TabView.backgroundColor=[UIColor greenColor];
    [self.view addSubview:TabView];
    return TabView;
}

-(void)close
{
    [self hidMainTabView:self.subTabView];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (tableView == self.mainTabView) {
        return    self.carList.count;
    }else{
        MainCar* car=self.carList[_selectMainRow];
        return car.subCars.count;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    UITableViewCell* cell=nil;

   if (tableView == self.mainTabView) {
        static NSString* identifire=@"identifire";
        
        cell=[tableView dequeueReusableCellWithIdentifier:identifire];
        
        if (cell==nil) {
            cell=[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifire];
        }
        MainCar* model=self.carList[indexPath.row];
        
        if (model.subCars.count > 0) {
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator; //显示最右边的箭头
        }
        cell.textLabel.text=model.name;
        cell.imageView.image=[UIImage imageNamed:model.icon];

    }else {
        static NSString* identifire=@"subidentifire";
        
        cell=[tableView dequeueReusableCellWithIdentifier:identifire];
        
        if (cell==nil) {
            cell=[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifire];
        }
        MainCar* model=self.carList[_selectMainRow];
        
        cell.textLabel.text=model.subCars[indexPath.row];
    }
    
    return cell;
}



-(void)btnClick
{
    [self showMainTabView:self.mainTabView];
  
}

#pragma mark -- 遮盖被点击
-(void)coverClick
{
    [self hidMainTabView:self.mainTabView];
    [self hidMainTabView:self.subTabView];
}


#pragma mark -- tabView 的展示与隐藏
-(void) showMainTabView:(UITableView*)tabView
{
    [UIView animateWithDuration:kDuration animations:^{
        CGRect f=tabView.frame;
        f.origin.x=kScreenWidth * 0.4;
        tabView.frame=f;
        self.cover.alpha=0.5;
    }];
}

-(void) hidMainTabView:(UITableView*)tabView
{
    [UIView animateWithDuration:kDuration animations:^{
        CGRect f=tabView.frame;
        f.origin.x=kScreenWidth ;
        tabView.frame=f;
        if (tabView == self.mainTabView) {
            self.cover.alpha=0.0;
        }
    }];
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if(tableView == self.mainTabView)
    {
        _selectMainRow=indexPath.row;
        MainCar* car=self.carList[indexPath.row];
        if (car.subCars.count > 0) {
            [self showMainTabView:self.subTabView];
            self.titleLabel.text=car.name;
            [self.subTabView  reloadData];
        }else{
            [self hidMainTabView:self.mainTabView];
            self.selectCarIcon=car.icon;
            self.selectCarType=car.name;
        }
    
    }else{
        [self coverClick];
        MainCar* car=self.carList[_selectMainRow];
        
        //NSString* str=car.subCars[indexPath.row];
        self.selectCarIcon=car.icon;
        self.selectCarType=car.subCars[indexPath.row];

    }
 }


-(void)setSelectCarIcon:(NSString *)selectCarIcon
{
    _selectCarIcon=selectCarIcon;
    [self.detailBtn  setImage:[UIImage imageNamed:selectCarIcon] forState:UIControlStateNormal];
}

-(void)setSelectCarType:(NSString *)selectCarType
{
    _selectCarType=selectCarType;
    [self.detailBtn setTitle:selectCarType forState:UIControlStateNormal];
}



@end
